﻿using Kivii.DataAnnotations;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.EmailPools.Entities
{
    [Api(Description = "邮箱池")]
    [Alias(Configs.TableNamePrefixEmailPool)]
    public class EmailPool<T> : EmailPoolBase, IEntityInGenericTypeDb, IEntityHasRemark, IEntity, IEntityHasCreator, IHasCreator, IEntityHasUpdater, IHasUpdater
    {
    }

    [Api(Description = "邮箱池")]
    public class EmailPool : EmailPoolBase,IEntityInAssemblyDb,
        IEntityHasRemark,
        IEntityHasCreator, IEntityHasUpdater
    { }
    public abstract class EmailPoolBase : EntityWithMetadata
    {
        #region 关联相关
        [IgnoreUpdate]
        [Required]
        public Guid OwnerKvid { get; set; }

        [StringLength(500)]
        public string OwnerName { get; set; }
        #endregion

        [ApiMember(Description = "收件地址")]
        [StringLength(100)]
        public string ToAddress { get; set; }

        [ApiMember(Description = "收件名称")]
        [StringLength(100)]
        public string ToName { get; set; }

        [ApiMember(Description = "寄件地址")]
        [StringLength(100)]
        public string FromAddress { get; set; }

        [ApiMember(Description = "寄件名称")]
        [StringLength(100)]
        public string FromName { get; set; }

        [ApiMember(Description = "邮件内容")]
        [StringLength(int.MaxValue)]
        public string Body { get; set; }

        [ApiMember(Description = "邮件主题")]
        [StringLength(200)]
        public string Subject { get; set; }

        [ApiMember(Description = "邮件正文是否为 HTML 格式")]
        public bool IsBodyHtml { get; set; }

        [ApiMember(Description = "分类")]
        [StringLength(50), Default("")]
        public string Category { get; set; }

        [ApiMember(Description = "是否发送")]
        [InternalSetter]
        public bool IsSended { get; set; }

        [ApiMember(Description = "附件地址")]
        [StringLength(1000)]
        public string FilePath { get; set; }

        [ApiMember(Description = "备注，最大3000字")]
        [StringLength(3000), Default("")]
        public string Remark { get; set; }

        [InternalSetter]
        [DefaultEmptyGuid]
        public Guid OperatorKvid { get; set; }

        [ApiMember(Description = "操作人")]
        [InternalSetter]
        [StringLength(100), Default("")]
        public string OperatorName { get; set; }

        [ApiMember(Description = "创建人Kvid ")]
        [IgnoreUpdate]
        [CurrentMemberKvid]
        public Guid CreatorKvid { get; set; }

        [ApiMember(Description = "创建人")]
        [IgnoreUpdate]
        [StringLength(50), CurrentMemberName]
        public string CreatorName { get; set; }

        [ApiMember(Description = "更新人Kvid ")]
        [CurrentMemberKvid]
        public Guid UpdaterKvid { get; set; }

        [ApiMember(Description = "更新人")]
        [StringLength(50), CurrentMemberName]
        public string UpdaterName { get; set; }
    }

    

}
